Support GRML_NAME, drop character limits, unify files in directory templates
[grml-live.git] / grml-live
1 #!/bin/bash
2 # Filename:      grml-live
3 # Purpose:       build process script for generating a (grml based) Linux Live-ISO
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2 or any later version.
7 # Latest change: Sat Sep 29 10:44:26 CEST 2007 [mika]
8 ################################################################################
9
10 # read configuration files, set some misc variables {{{
11
12 export LANG=C
13 export LC_ALL=C
14
15 # exit on any error:
16 set -e
17
18 # we need root permissions for the build-process:
19 if [ "$(id -u 2>/dev/null)" != 0 ] ; then
20    echo "Error: please run this script with uid 0 (root)." >&2
21    exit 1
22 fi
23
24 # make sure they are not set by default
25 VERBOSE=''
26 FORCE=''
27
28 if [ -r /etc/grml/lsb-functions ] ; then
29    . /etc/grml/lsb-functions
30 else
31    einfo()  { echo "  [*] $*" ;}
32    eerror() { echo "  [!] $*">&2 ;}
33    ewarn()  { echo "  [x] $*" ;}
34    eend()   { return 0 ;}
35 fi
36
37 # source main configuration file:
38 LIVE_CONF=/etc/grml/grml-live.conf
39 . $LIVE_CONF
40
41 PN=$(basename $0)
42 # }}}
43
44 # clean exit {{{
45 bailout() {
46   [ -n "$MIRROR_DIRECTORY" ] && umount "${CHROOT_TARGET}/${MIRROR_DIRECTORY}"
47   [ -n "$1" ] && EXIT="$1" || EXIT="1"
48   [ -n "$2" ] && eerror "$2">&2
49   exit "$EXIT"
50 }
51 trap bailout 1 2 3 15
52 # }}}
53
54 # check for important variables {{{
55 [ -n "$GRML_FAI_CONFIG" ] || GRML_FAI_CONFIG=/etc/grml/fai
56 [ -n "$HOSTNAME" ] || HOSTNAME=grml
57 [ -n "$USERNAME" ] || USERNAME=grml
58 [ -n "$CLASSES" ]  || CLASSES="GRML,I386"
59 [ -n "$BOOT_METHOD" ] || BOOT_METHOD='isolinux'
60 [ -n "$TARGET" ] || bailout 1 "${PN}: \$TARGET not specified. Please adjust $LIVE_CONF. Exiting."
61
62 [ -n "$VERSION" ]  || VERSION="0.0.1"
63 [ -n "$RELEASENAME" ] || RELEASENAME="grml-live rocks"
64 [ -n "$GRML_NAME" ] || GRML_NAME='grml'
65
66 [ -n "$LOGDIR" ] || LOGDIR="/var/log/fai/dirinstall/$HOSTNAME"
67 [ -d "$LOGDIR" ] || mkdir -p $LOGDIR
68 LOGFILE="$LOGDIR/grml-live.conf"
69 # }}}
70
71 # some important functions {{{
72
73 # log output:
74 # usage: log "string to log"
75 log() { echo "$*" >> $LOGFILE ; }
76
77 # cut string at character number int = $1
78 # usage: cut_string 5 "1234567890" will output "12345"
79 cut_string() {
80   [ -n "$2" ] || return 1
81   echo "$2" | head -c "$1"; echo -ne "\n"
82 }
83
84 # prepend int = $1 spaces before string = $2
85 # usage: extend_string_begin 5 "123" will output "  123"
86 extend_string_begin() {
87   [ -n "$2" ] || return 1
88   local COUNT="$(echo $2 | wc -c)"
89   local FILL="$(expr $COUNT - $1)"
90   while [ "$FILL" -gt 1 ] ; do
91     echo -n " "
92     local FILL=$(expr $FILL - 1)
93   done
94   while [ "$FILL" -lt 1 ] ; do
95     echo -n " "
96     local FILL=$(expr $FILL + 1)
97   done
98   echo "$2" | head -c "$1"; echo -ne "\n"
99 }
100
101 # append int = $1 spaces to string = $2
102 # usage: extend_string_begin 5 "123" will output "123  "
103 extend_string_end() {
104   [ -n "$2" ] || return 1
105   echo -n "$2" | head -c "$1"
106   local COUNT="$(echo $2 | wc -c)"
107   local FILL="$(expr $COUNT - $1)"
108   while [ "$FILL" -gt 1 ] ; do
109     echo -n " "
110     local FILL=$(expr $FILL - 1)
111   done
112   while [ "$FILL" -lt 1 ] ; do
113     echo -n " "
114     local FILL=$(expr $FILL + 1)
115   done
116   echo -ne "\n"
117 }
118 # }}}
119
120 # usage information {{{
121 usage()
122 {
123   echo "
124 $PN - build process script for generating a (grml based) Linux Live-ISO
125
126 Usage: $PN [-c <classe[s]>] [-g <grml_name>] [-i <iso_name> ] \\
127                  [-r <release_name>] [-s <suite>] [-t <target_directory>] \\
128                  [-v <version_number>] [-FVh]
129
130 Usage examples:
131
132     $PN
133     $PN -c GRMLBASE,GRML_X,I386 -t /grml/
134     $PN -c GRMLBASE,I386 -t /dev/shm/grml
135     $PN -c GRMLBASE,GRML_SMALL,I386 -g grml-small -v 1.0
136     $PN -c GRMLBASE,I386 -i grml_0.0-1.iso
137     $PN -c GRMLBASE,I386 -s sid -V
138
139 More details: man grml-live
140               /usr/share/doc/grml-live/grml-live.html
141
142 Please send your bug reports, feedback,.. to the grml-team.
143 http://grml.org/bugs/
144 "
145 }
146 # }}}
147
148 # command line parsing {{{
149
150 while getopts "c:g:i:r:s:t:v:FhV" opt; do
151   case "$opt" in
152     c) CLASSES="$OPTARG" ;;
153     g) GRML_NAME="$OPTARG" ;;
154     i) ISO_NAME="$OPTARG" ;;
155     r) RELEASENAME="$OPTARG" ;;
156     s) SUITE="$OPTARG" ;;
157     t) TARGET="$OPTARG"
158        CHROOT_TARGET="$TARGET/grml_chroot"
159        BUILD_TARGET="$TARGET/grml_cd"
160        ISO_TARGET="$TARGET/grml_isos"
161        ;;
162     v) VERSION="$OPTARG" ;;
163     F) FORCE=1 ;;
164     h) usage ; bailout 0 ;;
165     V) VERBOSE="-v" ;;
166     ?) echo "invalid option -$OPTARG" >&2; bailout 1 ;;
167   esac
168 done
169 shift $(($OPTIND - 1))  # set ARGV to the first not parsed commandline parameter
170
171 # }}}
172
173 # some misc checks before executing FAI {{{
174 [ -n "$CLASSES" ] || bailout 1 "Error: \$CLASSES unset, please set it in $LIVE_CONF or
175 specify it on the command line using the -c|--classes option."
176 [ -n "$TARGET" ] || bailout 1 "Error: \$TARGET unset, please set it in $LIVE_CONF or
177 specify it on the command line using the -t|--target option."
178 # }}}
179
180 # ask user whether the setup is ok {{{
181 if [ -z "$FORCE" ] ; then
182    echo
183    echo "${PN}: check your configuration (or use -F to force execution without prompting):"
184    echo
185    echo "  FAI classes:       $CLASSES"
186    echo "  main directory:    $TARGET"
187    [ -n "$CHROOT_TARGET" ] && echo "  chroot target:     $CHROOT_TARGET"
188    [ -n "$BUILD_TARGET" ]  && echo "  build target:      $BUILD_TARGET"
189    [ -n "$ISO_TARGET" ]    && echo "  ISO target:        $ISO_TARGET"
190    [ -n "$SUITE" ]         && echo "  Debian suite:      $SUITE"
191    [ -n "$BOOT_METHOD" ]   && echo "  Boot method:       $BOOT_METHOD"
192    [ -n "$FAI_ARGS" ]      && echo "  additional arguments for FAI: $FAI_ARGS"
193    [ -n "$VERBOSE" ]       && echo "  Using VERBOSE mode."
194    echo
195    echo -n "Is this ok for you? [y/N] "
196    read a
197    if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
198       bailout 1 "Exiting as requested."
199    fi
200    echo
201
202    start_seconds=$(cut -d . -f 1 /proc/uptime)
203    log "------------------------------------------------------------------------------"
204    log "Starting grml-live run [$(date)]"
205 fi
206 # }}}
207
208 # on-the-fly configuration {{{
209 if [ -n "$MIRROR_DIRECTORY" ] ; then
210    if ! [ -d "$MIRROR_DIRECTORY/debian" ] ; then
211       log "Sorry, $MIRROR_DIRECTORY/debian does not seem to exist. Exiting. [$(date)]"
212       eerror "Sorry, $MIRROR_DIRECTORY/debian does not seem to exist. Exiting."
213       bailout 1
214    fi
215    echo "$MIRROR_SOURCES" > /etc/grml/fai/apt/sources.list
216    if [ -n "$GRML_LIVE_SOURCES" ] ; then
217       echo "$GRML_LIVE_SOURCES" >> /etc/grml/fai/apt/sources.list
218    fi
219 elif [ -n "$GRML_LIVE_SOURCES" ] ; then
220    echo "$GRML_LIVE_SOURCES" > /etc/grml/fai/apt/sources.list
221 fi
222
223 if [ -n "$FAI_DEBOOTSTRAP" ] ; then
224    sed -i "s#^FAI_DEBOOTSTRAP=.*#FAI_DEBOOTSTRAP=\"$FAI_DEBOOTSTRAP\"#" /etc/grml/fai/make-fai-nfsroot.conf
225 fi
226
227 # does this suck? YES!
228 if [ -n "$SUITE" ] ; then
229    sed -i "s/SUITE=.*/SUITE=\"$SUITE\"/" $LIVE_CONF
230
231    DIST="\|\ etch\ \|\ stable\ \|\ lenny\ \|\ testing\ \|\ sid\ \|\ unstable\ "
232    sed -i "s/\(deb .\+\)\([ \t]+\)$DIST\([ \t]+\)\(main \)/\1\2 $SUITE \3\4/" $LIVE_CONF
233    sed -i "s/\(deb .\+\)\([ \t]+\)$DIST\([ \t]+\)\(main \)/\1\2 $SUITE \3\4/" /etc/grml/fai/apt/sources.list
234
235    DIST='\"etch\|=\"stable=\"lenny=\"testing=\"sid=\"unstable'
236    sed -i "s#FAI_DEBOOTSTRAP=$DIST#FAI_DEBOOTSTRAP=\"$SUITE#" $LIVE_CONF
237    sed -i "s#FAI_DEBOOTSTRAP=$DIST#FAI_DEBOOTSTRAP=\"$SUITE#" /etc/grml/fai/make-fai-nfsroot.conf
238 fi
239 # }}}
240
241 # CHROOT_TARGET - execute FAI {{{
242 [ -n "$CHROOT_TARGET" ] || CHROOT_TARGET="$TARGET/grml_chroot"
243
244 if [ -d "$CHROOT_TARGET/bin" ] ; then
245    log "$CHROOT_TARGET exists already, skipping stage 'fai dirinstall'"
246    ewarn "$CHROOT_TARGET exists already, skipping stage 'fai dirinstall'" ; eend 0
247 else
248    mkdir -p "$CHROOT_TARGET" || bailout 5 "Problem with creating $CHROOT_TARGET for FAI"
249    if [ -n "${MIRROR_DIRECTORY}" ] ; then
250       mkdir -p "${CHROOT_TARGET}/${MIRROR_DIRECTORY}"
251       mount --bind "${MIRROR_DIRECTORY}" "${CHROOT_TARGET}/${MIRROR_DIRECTORY}"
252    fi
253    fai $VERBOSE -C "$GRML_FAI_CONFIG" -c"$CLASSES" -u "$HOSTNAME" dirinstall "$CHROOT_TARGET" $FAI_ARGS | tee -a $LOGFILE
254    umount $CHROOT_TARGET/proc 2>/dev/null || /bin/true
255    umount $CHROOT_TARGET/sys  2>/dev/null || /bin/true
256    [ -n "$MIRROR_DIRECTORY" ] && umount "${CHROOT_TARGET}/${MIRROR_DIRECTORY}"
257
258    # notice: 'fai dirinstall' does not seem to exit appropriate, so:
259    ERROR=''
260    if [ -r "/var/log/fai/dirinstall/$HOSTNAME/software.log" ] ; then
261       grep 'dpkg: error processing' /var/log/fai/dirinstall/$HOSTNAME/software.log >> $LOGFILE && ERROR=1
262    fi
263
264    if [ -r "/var/log/fai/dirinstall/$HOSTNAME/shell.log" ] ; then
265       grep 'FAILED with exit code' /var/log/fai/dirinstall/$HOSTNAME/shell.log >> $LOGFILE && ERROR=2
266    fi
267
268    if [ -n "$ERROR" ] ; then
269       log "There was an error during execution of stage 'fai dirinstall' [$(date)]"
270       eerror "There was an error during execution of stage 'fai dirinstall'"
271       echo "   Check out /var/log/fai/dirinstall/$HOSTNAME/ for details. [exit ${ERROR}]"
272       eend 1 ; exit 1
273    else
274       log "Finished execution of stage 'fai dirinstall' [$(date)]"
275       einfo "Finished execution of stage 'fai dirinstall'"
276    fi
277 fi
278 # }}}
279
280 # BUILD_TARGET - execute arch specific stuff and squashfs {{{
281 [ -n "$BUILD_TARGET" ] || BUILD_TARGET="$TARGET/grml_cd"
282 mkdir -p "$BUILD_TARGET" || bailout 6 "Problem with creating $BUILD_TARGET for stage ARCH"
283
284 [ -n "$ARCH" ] || ARCH="$(dpkg --print-architecture)"
285
286 # i386:
287 if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
288    if [ -d "$BUILD_TARGET"/boot ] ; then
289       log "$BUILD_TARGET/boot exists already, skipping stage 'boot'"
290       ewarn "$BUILD_TARGET/boot exists already, skipping stage 'boot'" ; eend 0
291    else
292       # booting stuff:
293       mkdir -p "$BUILD_TARGET"/boot/isolinux
294       cp /boot/memtest86+.bin                              "$BUILD_TARGET"/boot/isolinux/memtest
295       cp "$CHROOT_TARGET"/boot/initrd*                     "$BUILD_TARGET"/boot/isolinux/initrd.gz
296       cp "$CHROOT_TARGET"/boot/vmlinuz*                    "$BUILD_TARGET"/boot/isolinux/linux26
297       cp /usr/lib/syslinux/chain.c32                       "$BUILD_TARGET"/boot/isolinux/
298       cp /usr/lib/syslinux/isolinux.bin                    "$BUILD_TARGET"/boot/isolinux/
299       cp /usr/lib/syslinux/memdisk                         "$BUILD_TARGET"/boot/isolinux/
300       cp /usr/lib/syslinux/menu.c32                        "$BUILD_TARGET"/boot/isolinux/
301       cp /usr/share/grml-live/templates/boot/isolinux/*    "$BUILD_TARGET"/boot/isolinux/
302       cp /usr/share/grml-live/templates/boot/isolinux/*    "$BUILD_TARGET"/boot/isolinux/
303       cp -a /usr/share/grml-live/templates/boot/grub       "$BUILD_TARGET"/boot/
304
305       [ -d "$BUILD_TARGET"/GRML ] || mkdir "$BUILD_TARGET"/GRML
306       cp -a /usr/share/grml-live/templates/GRML/* "$BUILD_TARGET"/GRML/
307
308       # adjust boot splash information:
309       ISO_DATE="$(date +%Y-%m-%d)"
310       RELEASE_INFO="$GRML_NAME $VERSION - Release Codename $RELEASENAME"
311       RELEASE_INFO="$(cut_string 68 "$RELEASE_INFO")"
312       RELEASE_INFO="$(extend_string_end 68 "$RELEASE_INFO")"
313
314       sed -i "s/%RELEASE_INFO%/$GRML_NAME $VERSION - $RELEASENAME/" "$BUILD_TARGET"/GRML/grml-version
315       sed -i "s/%DATE%/$ISO_DATE/"             "$BUILD_TARGET"/GRML/grml-version
316
317       sed -i "s/%RELEASE_INFO%/$RELEASE_INFO/" "$BUILD_TARGET"/boot/isolinux/boot.msg
318       sed -i "s/%DATE%/$ISO_DATE/"             "$BUILD_TARGET"/boot/isolinux/boot.msg
319
320       sed -i "s/%RELEASE_INFO%/$RELEASE_INFO/" "$BUILD_TARGET"/boot/isolinux/boot-beep.msg
321       sed -i "s/%DATE%/$ISO_DATE/"             "$BUILD_TARGET"/boot/isolinux/boot-beep.msg
322
323       sed -i "s/%VERSION%/$VERSION/"           "$BUILD_TARGET"/boot/grub/menu.lst
324       sed -i "s/%GRML_NAME%/$GRML_NAME/"       "$BUILD_TARGET"/boot/grub/menu.lst
325
326       # autostart for Windows:
327       cp /usr/share/grml-live/templates/windows/autostart/* "$BUILD_TARGET"/
328       # windows-binaries:
329       if [ -n "$WINDOWS_BINARIES" ] ; then
330          if [ -f "$BUILD_TARGET"/windows/putty.exe ] ; then
331             log "$BUILD_TARGET/windows exists already, skipping stage 'WINDOWS_BINARIES'"
332             ewarn "$BUILD_TARGET/windows exists already, skipping stage 'WINDOWS_BINARIES'" ; eend 0
333          else
334             mkdir "$BUILD_TARGET"/windows
335             ( cd "$BUILD_TARGET"/windows
336               for file in pageant plink pscp psftp putty puttygen ; do
337                  wget -O ${file}.exe ${WINDOWS_BINARIES}/${file}.exe
338               done )
339          fi
340       log "Finished execution of stage 'WINDOWS_BINARIES' [$(date)]"
341       einfo "Finished execution of stage 'WINDOWS_BINARIES'" ; eend 0
342       fi
343    einfo "Finished execution of stage 'boot'" ; eend 0
344    fi
345 # ppc:
346 elif [ "$ARCH" = powerpc ] ; then
347     ewarn 'Warning: formorer, it is your turn. :)'>&2
348 # unsuported:
349 else
350    eerror 'Error: Unsupported ARCH, sorry. Want to support it? Contribute!' ; eend 1
351 fi
352
353 if [ -f "$BUILD_TARGET"/live/grml.squashfs ] ; then
354    log "$BUILD_TARGET/live exists already, skipping stage 'squashfs'"
355    ewarn "$BUILD_TARGET/live exists already, skipping stage 'squashfs'" ; eend 0
356 else
357    mkdir "$BUILD_TARGET"/live
358    mksquashfs $CHROOT_TARGET/* $BUILD_TARGET/live/grml.squashfs -noappend
359    log "Finished execution of stage 'squashfs' [$(date)]"
360    einfo "Finished execution of stage 'squashfs'" ; eend 0
361 fi
362
363 # create md5sum file:
364 ( cd $BUILD_TARGET/GRML &&
365 find .. -type f -not -name md5sums -exec md5sum {} \; > md5sums )
366 # }}}
367
368 # ISO_TARGET - mkisofs {{{
369 [ -n "$ISO_TARGET" ] || ISO_TARGET="$TARGET/grml_isos"
370 [ -n "$ISO_NAME" ] || ISO_NAME="$GRML_NAME_${VERSION}.iso"
371
372 if [ "$BOOT_METHOD" = "isolinux" ] ; then
373    BOOT_FILE="boot/isolinux/isolinux.bin -c boot/isolinux/boot.cat"
374 elif [ "$BOOT_METHOD" = "grub" ] ; then
375    BOOT_FILE="boot/grub/stage2_eltorito"
376 fi
377
378 if [ -f "${ISO_TARGET}/${ISO_NAME}" ] ; then
379    log "$ISO_TARGET exists already, skipping stage 'iso build'"
380    ewarn "$ISO_TARGET exists already, skipping stage 'iso build'" ; eend 0
381 else
382    mkdir -p "$ISO_TARGET" || bailout 6 "Problem with creating $ISO_TARGET for stage 'iso build'"
383    CURRENT_DIR=$(pwd)
384    cd "$BUILD_TARGET" &&
385    mkisofs -V "grml $VERSION" -publisher 'grml-live | grml.org' \
386            -l -r -J -no-emul-boot -boot-load-size 4 -boot-info-table    \
387            -b $BOOT_FILE \
388            -o "${ISO_TARGET}/${ISO_NAME}" . ; RC=$?
389    cd $CURRENT_DIR
390    if [ "$RC" = 0 ] ; then
391       log "Finished execution of stage 'iso build' [$(date)]"
392       einfo "Finished execution of stage 'iso build'" ; eend 0
393    else
394       log "There was an error ($RC) executing stage 'iso build' [$(date)]"
395       eerror "There was an error executing stage 'iso build'" ; eend 1
396       bailout $RC
397    fi
398 fi
399 # }}}
400
401 # finalize {{{
402 [ -n "$start_seconds" ] && SECONDS="$[$(cut -d . -f 1 /proc/uptime)-$start_seconds]"
403 einfo "Sucessfully finished execution of $PN [running ${SECONDS} seconds]" ; eend 0
404 log "Sucessfully finished execution of $PN [running ${SECONDS} seconds]"
405 log "------------------------------------------------------------------------------"
406 bailout 0
407 # }}}
408
409 ## END OF FILE #################################################################
410 # vim:foldmethod=marker ts=2 ft=sh ai expandtab tw=80 sw=3